/* 	================================================================

	1001-1 Plateaus Interface
	
	version 0.3beta DR 1
	
	Ce text peut tre librement reproduit, traduit ou adapt, mme 
	sans indication d'origine.


	Any commercial use is prohibited.
	This program may can bugs able to destroy your software, harddisk
	or hardware, desktop, room, house, street, city, planet.
		Use at own risk.

	bug reports etc.: 1001-1 interface <eistein@zedat.fu-berlin.de>

	/!\	Never use <LAYER...>-tags within your documents if you include
		this library, or Netscape will produce hardcore crashes.
		
		Make a css-style: "div.myLayer { position:absolute }",
		and use the <DIV>-tag: "<DIV class='myLayer'></DIV>".

	================================================================ */


var gPlateausEbene = 10; 		// zIndex common to all Plateaus

var gFocus						// the focussed layer in a mouse process. gFocus.ref points
								// to the layer's plateau
var gCurrentOffX, gCurrentOffY;

// The Plateau constructor maintains a document.Plateaus-array, containing
// all created Plateaus. E.g. document.Plateaus[0].src = "content.html".
// (delete doesn't work, sorry)



/* -- HIGH LEVEL FUNCTIONS ---------------------------------------------------------------------- */

function openPlateau( pTitle, pSrc, pRect, pFlags, pLayout ) {
	// mirrors the Plateau-constructor params
	// Plateaus are identified with their .title-property
	
	var b;
	
	if ( document.Plateaus ) {
		for ( a = 0; a < document.Plateaus.length; a++ ) {
			if ( document.Plateaus[a].title == pTitle ) {
				b = document.Plateaus[a];
				break;
			}
		}
	}
	if (!b) b = new Plateau( pTitle, pSrc, pRect, pFlags, pLayout );
	else {
		// bring to front
		b.main.zIndex = gPlateausEbene;
		b.main.visibility = 'show';
	}
	
	// return b;
}

Plateau.closePlateau = function () {
	// this := [Plateau]
	this.main.visibility = 'hide';
}


/* == PLATEAU OBJECT ============================================================================ */

Plateau.defaultLayout = function () {
	// this := [Plateau]
	// returns HTML Table code for window content

	// /!\	Your HTML Code must include the <div class=plateauContent></div>-tag, or
	// 		you will get into real problems.

	a = // '<style type="text/css" src="1001-1.css"></style>' +
		'<table border=1 cellSpacing=0 width='+ this.w + '>\n' +
		'<tr><td class=head>'+ this.title +'</td></tr>\n' +
		'<tr><td width='+ this.w +' height='+ ( this.h - 18 ) + '>' +

		// content object (class defaultLayout implements absolute position):
		'&nbsp;<div class=defaultLayout>please wait...</div>' +
		
		'</td></tr><tr><td height=1> </td></tr></table>';
	
	return a;
}

Plateau.defaultVirtualZone = function (e, layerObj) {
	// Determines the window dekor element (closeBox, titleBar, growBox)

	objRight = layerObj.left + layerObj.clip.width;
	objBottom = layerObj.top + layerObj.clip.height;
	
	leftBorder = ( e.pageX < layerObj.left + 20 );
	rightBorder = ( e.pageX > objRight - 20 );
	topBorder = ( e.pageY < layerObj.top + 20 );
	bottomBorder = ( e.pageY > objBottom - 20 );
	
	if ( topBorder ) {													// title bar
		if ( leftBorder ) return "close";								// virtual close box
		else if ( rightBorder ) return "shade";							// virtual shade box
		else return "drag";
		
	} else if ( bottomBorder ) {
		if ( rightBorder ) return "grow";								// virtual grow box

	}
	
	if ( rightBorder || bottomBorder )
		return "moveContent";											// move Plateau content

	if ( e.modifiers == Event.ALT_MASK )
		return "moveContent";											// move Plateau content
	
	return null; 														// no dekor element clicked
}


/* -- DISPLAY METHODS --------------------------------------------------------------------------- */

Plateau.refresh = function () {
	// this := [Plateau]
	
	// save some content infos
	if ( this.content ) {
		var oldLeft = this.content.left;
		var oldTop = this.content.top;
		var oldClipLeft = this.content.clip.left;
		var oldClipTop = this.content.clip.top;
		var gotOlds = true;
	} else var gotOlds = false;
	
	// rebuild content
	this.main.document.open('text/html');
	this.main.document.write(this.layout());
	this.main.document.close();

	var contentLayer = this.main.document.layers[0];

	// init content layer
	contentLayer.visibility = 'inherit';

	if ( gotOlds == true ) {
		contentLayer.left = oldLeft;
		contentLayer.top = oldTop;
		contentLayer.clip.left = oldClipLeft;
		contentLayer.clip.top = oldClipTop;

	} else {
		contentLayer.clip.left = 0;
		contentLayer.clip.right = 0;
	}

	contentLayer.clip.right = 
		this.main.clip.right - contentLayer.left - 2; 						// 2 + 2 (Rand: 2px)
	contentLayer.clip.bottom = 
		this.main.clip.bottom - contentLayer.top - 2;							// e.g. 18 + 2

	contentLayer.bgColor = this.bgColor;
	contentLayer.src = this.src;											// load content

	// unhilite or update
	this.main.bgColor = this.bgColor;
	
	this.content = contentLayer;
}


/* -- SCHNITTPLATZ HANDLERS --------------------------------------------------------------------- */

Plateau.onmousedown = function (e) {
	// this method gets called if someone clicks on the plateau layer
	// -> this := [layer], this.ref := [Plateau]
	
	window.defaultStatus = ''; // --@

	// mouseDown handler defined?
	// if (this.ref.ondown)
	//   this.ref.ondown(this.ref);

	// clicked --> bring to front
	if ( document.dontBringToFront != true ) this.zIndex = gPlateausEbene;
	// hilite
	this.bgColor = '#3a3366';
	
	// save offset to layer topLeft
	gCurrentOffX = this.left - e.pageX;
	gCurrentOffY = this.top - e.pageY;


	// it's necessary to capture events from window level
	// weil das Plateau sonst nicht mehr reagiert, wenn die mouse raus ist
	gFocus = this;					// save global object pointer for use in window event handlers

	window.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);
	window.oldmousemove = window.onmousemove;							// save old window methods
	window.oldmouseup = window.onmouseup;
	window.onmouseup = this.ref.onmouseup;
	
	ourEvent = this.ref.virtualZone(e, this);
	switch ( ourEvent ) {
		case ( "shade" ) :
			this.ref.shadePlateau();
			break;
		case ( "drag" ) :
			window.onmousemove = this.ref.dragPlateau;
			break;
		case ( "grow" ) :
			window.onmousemove = this.ref.growPlateau;
			break;
		case ( "close" ) :
			this.ref.close();
			break;
		case ( "moveContent" ) :
			window.onmousemove = this.ref.scrollPlateau;
			break;
		default:
			return true; // continue system handling of mouseDown event
	}

	return false; // mouseDown handled
}

Plateau.onmouseup = function () {
	// --@ restore old event mask
	window.releaseEvents(Event.MOUSEMOVE|Event.MOUSEUP);
	// restore old handlers
	window.onmousemove = window.oldmousemove;
	window.onmouseup = window.oldmouseup;

	// unhilite
	gFocus.bgColor = gFocus.ref.bgColor;

	// refresh? e.g. after a grow process
	if ( gFocus.bRefresh ) {
		gFocus.ref.refresh();
		gFocus.bRefresh = false;
	}
	
	return false; // handled
}


Plateau.dragPlateau = function (e) {
	// mouseMove handler defined?
	// if (this.ref.onmove)
	//	this.ref.onmove(this.ref);

	gFocus.left = e.pageX + gCurrentOffX;
	gFocus.top = e.pageY + gCurrentOffY;
	
	gFocus.ref.left = gFocus.left;
	gFocus.ref.top = gFocus.top;
	
	return false; // handled
}

Plateau.growPlateau = function (e) {
	var newWidth = e.pageX - gFocus.left;
	var newHeight = e.pageY - gFocus.top;

	newWidth = ( newWidth > 200 ) ? newWidth : 200 ;				// minimal rect
	newHeight = ( newHeight > 120 ) ? newHeight : 120 ;

	gFocus.clip.right = newWidth;
	gFocus.clip.bottom = newHeight;
	
	gFocus.ref.w = newWidth;
	gFocus.ref.h = newHeight;

	gFocus.bRefresh = true; // force refresh after mouseup
}

Plateau.scrollPlateau = function (e) {
	offX = ( gCurrentOffX - ( gFocus.left - e.pageX ));
	offY = ( gCurrentOffY - ( gFocus.top - e.pageY ));

	if ( gFocus.ref.bSchizoScroll ) {
		offX = 0 - offX;
		offY = 0 - offY;
	}
	
	gCurrentOffX = gFocus.left - e.pageX;
	gCurrentOffY = gFocus.top - e.pageY;

	gFocus.ref.content.left = gFocus.ref.content.left + offX;
	gFocus.ref.content.top = gFocus.ref.content.top + offY;
	gFocus.ref.content.clip.left = gFocus.ref.content.clip.left - offX;
	gFocus.ref.content.clip.right = gFocus.ref.content.clip.right - offX;
	gFocus.ref.content.clip.top = gFocus.ref.content.clip.top - offY;
	gFocus.ref.content.clip.bottom = gFocus.ref.content.clip.bottom - offY;
}

Plateau.shadePlateau = function () {
	if ( !this.bShaded ) {
		this.main.clip.bottom = 18;
		this.bShaded = true;
	} else {
		this.main.clip.bottom = this.h;
		this.bShaded = false;
	}
}


/* -- CONSTRUCTOR CONSTRUCTOR ------------------------------------------------------------------- */ 

function Plateau( pTitle, pSrc, pRect, pFlags, pLayout ) {
	// Plateau Constructor
	// -> this := the new created [Plateau]

	// pFlags:
	//		schizoScroll
	//		dontDrag
	//		dontScroll
	//		dontGrow
	//		dontShade

	// pLayout
	//		pLayout[0] : layout function
	//		pLayout[1] : virtual zone function


	/* -- init Plateau Eigenschaften -------- */
	this.title = pTitle || "#empty";
	this.src = pSrc;

	this.bgColor = '#111111';

	this.left = 100; this.top = 200;			// default rect
	this.w = 240; this.h = 160;
	if ( pRect ) {
		if ( pRect[0] ) {
			this.left = pRect[0];
			if ( pRect[1] ) {
				this.top = pRect[1];
				if ( pRect[2] ) {
					this.w = pRect[2];
					if ( pRect[3] ) this.h = pRect[3];
				}
			}
		}
	}

	for ( a in pFlags ) {
		switch ( a ) {
			case ('schizoScroll' ) :
				this.bSchizoScroll = true; break;
			case ('dontDrag' ) :
				this.dontDrag = true; break;
			case ('dontScroll' ) :
				this.dontScroll = true; break;
			case ('dontGrow' ) :
				this.dontGrow = true; break;
			case ('dontShade' ) :
				this.dontShade = true; break;
		}
	}
	
	
	/* WARUM IST DAS NICHT SCHON GETAN ?? */
	/* Warum gehren diese Methoden nicht zum Plateau-Prototype?? */
	
	// layout methods:
	this.layout = defaultLayout;
	if ( pLayout ) if ( pLayout[0] )
		this.layout = pLayout[0];

	this.virtualZone = defaultVirtualZone;
	if ( pLayout ) if ( pLayout[1] )
		this.virtualZone = pLayout[1];

	this.refresh = refresh;

	// so-called interaction methods:
	this.dragPlateau = dragPlateau;
	this.growPlateau = growPlateau;
	this.scrollPlateau = scrollPlateau;
	this.shadePlateau = shadePlateau;
	this.close = closePlateau;
	this.onmouseup = onmouseup;
	

	/* -- create new Layer -------- */
	this.main = new Layer( this.w );		 				// width seems to have no effect
															// but Netscape makes no new L. without
	
	this.main.ref = this;									// add pointer from layer to plateau

	this.zIndex = gPlateausEbene;
	
	this.main.left = this.left;
	this.main.top = this.top;
	this.main.clip.right = this.w;
	this.main.clip.bottom = this.h;

	/* -- draw plateau content -------- */
	this.refresh();
	
	/* -- init event capturing -------- */
	this.main.captureEvents(Event.MOUSEDOWN);
	// Note: 	More Events will be captured while handling specific tasks
	//			like dragging etc.
	this.main.onmousedown = onmousedown;

	this.main.visibility = 'show';

	/* -- Update document Plateau references -------- */
	if (!document.Plateaus) document.Plateaus = new Array();
	// document.Plateaus += this;
	document.Plateaus[document.Plateaus.length] = this;

	return this;
}
Plateau.prototype = new Object();

window.defaultStatus = "1001-1 Plateaus interface.inited";



/* -- UNSUPPORTED ------------------------------------------------------------------------------- */

function _debug() {
	var a = '';
	
	for ( i = 0; i < _debug.arguments.length; i++ ) {
		a += _debug.arguments[i] + "/ ";
	}
	window.defaultStatus = a;
}

function _debugA() {
	var a = '';
	
	for ( i = 0; i < _debugA.arguments.length; i++ ) {
		a += _debugA.arguments[i] + "/ ";
	}
	alert(a);
}

/* -- GENERIC HELPERS --------------------------------------------------------------------------- */

function ourRandom( n ) {
	return Math.abs(Math.round(Math.random()*n)-1);
}

function setCoverSize( w, h ) {
	document.width = w;
	document.height = h;
}
